]>
Commit | Line | Data |
---|---|---|
dcecc6c7 | 1 | #!/bin/sh |
b2441318 | 2 | # SPDX-License-Identifier: GPL-2.0 |
dcecc6c7 RD |
3 | # Disassemble the Code: line in Linux oopses |
4 | # usage: decodecode < oops.file | |
5 | # | |
6 | # options: set env. variable AFLAGS=options to pass options to "as"; | |
7 | # e.g., to decode an i386 oops on an x86_64 system, use: | |
8 | # AFLAGS=--32 decodecode < 386.oops | |
d72e720a | 9 | # PC=hex - the PC (program counter) the oops points to |
dcecc6c7 | 10 | |
fa220d89 | 11 | cleanup() { |
5358db0b | 12 | rm -f $T $T.s $T.o $T.oo $T.aa $T.dis |
fa220d89 RD |
13 | exit 1 |
14 | } | |
15 | ||
16 | die() { | |
17 | echo "$@" | |
18 | exit 1 | |
19 | } | |
20 | ||
21 | trap cleanup EXIT | |
22 | ||
23 | T=`mktemp` || die "cannot create temp file" | |
dcecc6c7 | 24 | code= |
7e68b361 | 25 | cont= |
dcecc6c7 RD |
26 | |
27 | while read i ; do | |
28 | ||
29 | case "$i" in | |
30 | *Code:*) | |
31 | code=$i | |
7e68b361 AS |
32 | cont=yes |
33 | ;; | |
34 | *) | |
35 | [ -n "$cont" ] && { | |
36 | xdump="$(echo $i | grep '^[[:xdigit:]<>[:space:]]\+$')" | |
37 | if [ -n "$xdump" ]; then | |
38 | code="$code $xdump" | |
39 | else | |
40 | cont= | |
41 | fi | |
42 | } | |
dcecc6c7 RD |
43 | ;; |
44 | esac | |
45 | ||
46 | done | |
47 | ||
48 | if [ -z "$code" ]; then | |
fa220d89 | 49 | rm $T |
dcecc6c7 RD |
50 | exit |
51 | fi | |
52 | ||
53 | echo $code | |
54 | code=`echo $code | sed -e 's/.*Code: //'` | |
55 | ||
5358db0b | 56 | width=`expr index "$code" ' '` |
b396aa03 | 57 | width=$((($width-1)/2)) |
5358db0b RV |
58 | case $width in |
59 | 1) type=byte ;; | |
60 | 2) type=2byte ;; | |
61 | 4) type=4byte ;; | |
62 | esac | |
63 | ||
c5cfb62f MZ |
64 | if [ -z "$ARCH" ]; then |
65 | case `uname -m` in | |
66 | aarch64*) ARCH=arm64 ;; | |
67 | arm*) ARCH=arm ;; | |
68 | esac | |
69 | fi | |
70 | ||
d72e720a | 71 | # Params: (tmp_file, pc_sub) |
5358db0b | 72 | disas() { |
d72e720a BP |
73 | t=$1 |
74 | pc_sub=$2 | |
75 | ||
76 | ${CROSS_COMPILE}as $AFLAGS -o $t.o $t.s > /dev/null 2>&1 | |
5358db0b | 77 | |
b396aa03 RV |
78 | if [ "$ARCH" = "arm" ]; then |
79 | if [ $width -eq 2 ]; then | |
5358db0b RV |
80 | OBJDUMPFLAGS="-M force-thumb" |
81 | fi | |
82 | ||
d72e720a | 83 | ${CROSS_COMPILE}strip $t.o |
5358db0b RV |
84 | fi |
85 | ||
be9fa663 WD |
86 | if [ "$ARCH" = "arm64" ]; then |
87 | if [ $width -eq 4 ]; then | |
88 | type=inst | |
89 | fi | |
90 | ||
d72e720a | 91 | ${CROSS_COMPILE}strip $t.o |
be9fa663 WD |
92 | fi |
93 | ||
d72e720a BP |
94 | if [ $pc_sub -ne 0 ]; then |
95 | if [ $PC ]; then | |
96 | adj_vma=$(( $PC - $pc_sub )) | |
97 | OBJDUMPFLAGS="$OBJDUMPFLAGS --adjust-vma=$adj_vma" | |
98 | fi | |
99 | fi | |
100 | ||
101 | ${CROSS_COMPILE}objdump $OBJDUMPFLAGS -S $t.o | \ | |
102 | grep -v "/tmp\|Disassembly\|\.text\|^$" > $t.dis 2>&1 | |
5358db0b RV |
103 | } |
104 | ||
dcecc6c7 RD |
105 | marker=`expr index "$code" "\<"` |
106 | if [ $marker -eq 0 ]; then | |
107 | marker=`expr index "$code" "\("` | |
108 | fi | |
109 | ||
d72e720a | 110 | |
846442c8 | 111 | touch $T.oo |
dcecc6c7 | 112 | if [ $marker -ne 0 ]; then |
d72e720a BP |
113 | # 2 opcode bytes and a single space |
114 | pc_sub=$(( $marker / 3 )) | |
846442c8 AV |
115 | echo All code >> $T.oo |
116 | echo ======== >> $T.oo | |
117 | beforemark=`echo "$code"` | |
5358db0b RV |
118 | echo -n " .$type 0x" > $T.s |
119 | echo $beforemark | sed -e 's/ /,0x/g; s/[<>()]//g' >> $T.s | |
d72e720a | 120 | disas $T $pc_sub |
5358db0b RV |
121 | cat $T.dis >> $T.oo |
122 | rm -f $T.o $T.s $T.dis | |
dcecc6c7 RD |
123 | |
124 | # and fix code at-and-after marker | |
125 | code=`echo "$code" | cut -c$((${marker} + 1))-` | |
126 | fi | |
846442c8 AV |
127 | echo Code starting with the faulting instruction > $T.aa |
128 | echo =========================================== >> $T.aa | |
5358db0b RV |
129 | code=`echo $code | sed -e 's/ [<(]/ /;s/[>)] / /;s/ /,0x/g; s/[>)]$//'` |
130 | echo -n " .$type 0x" > $T.s | |
dcecc6c7 | 131 | echo $code >> $T.s |
d72e720a | 132 | disas $T 0 |
5358db0b | 133 | cat $T.dis >> $T.aa |
846442c8 | 134 | |
18ff44b1 BP |
135 | # (lines of whole $T.oo) - (lines of $T.aa, i.e. "Code starting") + 3, |
136 | # i.e. the title + the "===..=" line (sed is counting from 1, 0 address is | |
137 | # special) | |
138 | faultlinenum=$(( $(wc -l $T.oo | cut -d" " -f1) - \ | |
139 | $(wc -l $T.aa | cut -d" " -f1) + 3)) | |
140 | ||
2a95e37c | 141 | faultline=`cat $T.dis | head -1 | cut -d":" -f2-` |
5358db0b | 142 | faultline=`echo "$faultline" | sed -e 's/\[/\\\[/g; s/\]/\\\]/g'` |
846442c8 | 143 | |
e08df079 | 144 | cat $T.oo | sed -e "${faultlinenum}s/^\([^:]*:\)\(.*\)/\1\*\2\t\t<-- trapping instruction/" |
846442c8 AV |
145 | echo |
146 | cat $T.aa | |
147 | cleanup |